﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
FO_CONFIRM_EVENTS.JS is the core event file for all code
specific to the FO_CONFIRM.HTML form.

The core Drag/Drop function in MAIN will call here to alert
that a single file was moved.

NOTE: External dependencies are added in the parent HTML
*/

/*============================================================
FUNCTION:   init ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Sets the window timeout to 6 seconds, then loads the:
- filename
- extnesion type
- folder path
from the settings where they were placed by the 
main_events.ondrop function.
==============================================================*/ 
function init()
{
    // read the settings...
    document.getElementById("fileName").innerText = System.Gadget.document.parentWindow.mainParam_fileName;
    document.getElementById("typeName").innerText = System.Gadget.document.parentWindow.mainParam_typeName;
    document.getElementById("folderPath").innerText = System.Gadget.document.parentWindow.mainParam_folderPath;
    
    window.setTimeout("initFocus()",300);
}

/*============================================================
FUNCTION:   initFocus ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/28/2007
DESCRIPTION:
Called to correct a refresh bug. Also sets the window timeout.
==============================================================*/ 
function initFocus()
{    
    getFocus();
    window.setTimeout("close()",7000);
}

/*============================================================
FUNCTION:   openFolder ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/26/2007
DESCRIPTION:
Called from the onclick functionality of a hyperlin on the form
to allow for the specified folder to be opened in Windows
Explorer.
==============================================================*/ 
function openFolder()
{
    var path = document.getElementById("folderPath").innerText;
    var fso = getFSO();
    if (fso==null) return;
    if (fso.FolderExists(path)==true)
        System.Shell.execute(path,0,0,"explore");
}

/*============================================================
FUNCTION:   close ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Closes the flyout window.
==============================================================*/ 
function close()
{
    System.Gadget.Flyout.show=false;
}

/*============================================================
FUNCTION:   okButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Closes the flyout window.
==============================================================*/ 
function okButton_onclick() 
{
    close();
}

