﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
FO_JUMP_EVENTS.JS is the core event file for all code
specific to the FO_JUMP.HTML form.

The core Drag/Drop function in MAIN will call here is there
are multiple files that were moved by one operation.

NOTE: External dependencies are added in the parent HTML
*/

var fBulk = false;

/*============================================================
FUNCTION:   init ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/28/2007
MODIFIED:   05/05/2007
DESCRIPTION:
Load the folder data.
////////////////////////////////////////////////////////////////
// How is this flyout being used:
// 1. User clicked the folder icon and we show the jump to option
// 2. User moving a bulk of files to another folder
////////////////////////////////////////////////////////////////
==============================================================*/ 
function init()
{
    
    var fil = coreOpenSettings(1);
    if (fil == null) return;
    
    try {
        while(fil.AtEndOfStream==false)
        {
            // load the data
            var strName = fil.ReadLine();
            var strTypes = fil.ReadLine();
            var strPath = fil.ReadLine();
            
            selFolder.options[selFolder.length] = new Option(strName, strPath);
        }
        fil.Close();
    } catch (err) { 
        throwError("Reading settings file. " + err.description); 
        return;
    }
    
    sortlist(selFolder);
    
    // how is this flyout being used:
    if(System.Gadget.document.parentWindow.mainProcess_bulkMove)
    {
        mainLabel.innerText =  "Select a folder location to move the file(s):"
        fBulk = true;
        System.Gadget.document.parentWindow.mainProcess_bulkMove = false;
    }
    else
        mainLabel.innerText = "Select a folder location you would like to open:"
    
    // set focus
    window.setTimeout("initFocus()",300);
}

/*============================================================
FUNCTION:   okButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/28/2007
DESCRIPTION:
Browse to the specific area...
==============================================================*/ 
function initFocus()
{    
    getFocus();
    window.setTimeout("close()",7000);
}

/*============================================================
FUNCTION:   okButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/28/2007
DESCRIPTION:
Browse to the specific area...
==============================================================*/ 
function okButton_onclick() 
{
    var path = selFolder.options[selFolder.selectedIndex].value;
    if(!fBulk)
    {
        var fso = getFSO();
        if (fso==null) return;
        if(fso.FolderExists(path))
            System.Shell.execute(path,0,0,"explore");
        else
            throwError("The specified path is invalid: \n\n" + path);
    }
    else
    {
        System.Gadget.document.parentWindow.mainResult_bulkPath = path;
    }
    
    try{
        System.Gadget.document.parentWindow.mainEventDetect_bulkCancel = false;
        System.Gadget.Flyout.show=false;
    }catch(err){ }
}

/*============================================================
FUNCTION:   cancelButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/05/2007
DESCRIPTION:
Cancel the form
==============================================================*/ 
function cancelButton_onclick()
{
    System.Gadget.document.parentWindow.mainEventDetect_bulkCancel = true;
    System.Gadget.Flyout.show=false;
}

/*============================================================
FUNCTION:   selFolder_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/28/2007
DESCRIPTION:
Enabled the OK button...
==============================================================*/ 
function selFolder_onchange()
{
    if(!fBulk)
    {
        disableButton(cancelButton);
        selFolder.disabled="disabled";
        okButton_onclick();
    }
    else
    {
        enableButton(okButton);
    }
}
