﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
FO_UNKNOWN_EVENTS.JS is the core event file for all code
specific to the FO_UNKNOWN.HTML form.

The basic functionality is to handle new unknown extensions.
The core Drag/Drop function in MAIN will load the UNKNOWN
file within the flyout to handle the registration of the
new file extension.

NOTE: External dependencies are added in the parent HTML
*/

var newItem = false; // global

/*============================================================
FUNCTION:   init ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Gets the filename and extension setting saved from the
main_events.js. Reads in all the section names from the
core settings file, then adds them to the selection dropdown
==============================================================*/ 
function init()
{
    // read the settings...
    document.getElementById("fileName").innerText = System.Gadget.document.parentWindow.mainParam_fileName;
    document.getElementById("extension").innerText = System.Gadget.document.parentWindow.mainParam_extension;
    
    // some files do not have an extension. In those cases
    // the form will change a little...
    if (System.Gadget.document.parentWindow.mainParam_extension.length==0)
    {
        exTable.innerHTML = "";
        exType.innerText = " does not have an extension.";
        disableButton(addButton); // cannot add new location here
    }
    
    // open the settings file
    var fil = coreOpenSettings(1);
    if(fil==null) 
    {
        close();
        return;
    }
    
    // read it...
    try {
        while(fil.AtEndOfStream==false)
        {
            // load the data
            var strName = fil.ReadLine();
            var strTypes = fil.ReadLine();
            var strPath = fil.ReadLine();
            
            selType.options[selType.length] = new Option(strName, strPath);
        }
        fil.Close();
        
    } catch (err) { 
        close();
        throwError("Reading settings file. " + err.description); 
        return;
    }
    
    window.setTimeout("getFocus()", 300);
}

/*============================================================
FUNCTION:   close ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Closes the form
==============================================================*/ 
function close()
{
    System.Gadget.Flyout.show=false;
}

/*============================================================
FUNCTION:   addButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Unhides the controls so that the user is presented with
options to allow them to name a new location type and
path...
==============================================================*/ 
function addButton_onclick() 
{
    typeLabel.innerText = "Please enter a name for this file type:";
    selType.style.visibility="hidden";
    txtNewType.style.visibility="";
    hiddenTemp.innerHTML=insertHere.innerHTML;
    insertHere.innerHTML=hiddenSpot.innerHTML;
    hiddenSpot.innerHTML="";
    addTable.style.visibility="";
    newItem=true;
    disableButton(addButton);
}

/*============================================================
FUNCTION:   cancelButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Close the flyout
==============================================================*/ 
function cancelButton_onclick() 
{   
    System.Gadget.document.parentWindow.mainEventDetect_moveCancel = true;
    close();    
}

/*============================================================
FUNCTION:   okButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Validates the form data and either:
- Adds a new extension to an existing named path location
- Or, it adds a new named path locaiton and places the 
  new extension in it
==============================================================*/ 
function okButton_onclick() 
{
    // verify the data...
    if (selType.style.visibility=="" && selType.value.length==0 )
    {
        showMessage("You must select folder to continue.");
        System.Sound.beep();
        return;
    }
    // add the item to the list...
    if(!newItem)
    {
        if(System.Gadget.document.parentWindow.mainParam_extension.length>0)
        {
            if(!writeNewExtension(selType.options[selType.selectedIndex].text,
                                  System.Gadget.document.parentWindow.mainParam_extension)
              ) return;
        }
        // add the path to the settings so the return function can mve the file...
        System.Gadget.document.parentWindow.mainResult_newPath = selType.options[selType.selectedIndex].value;
        System.Gadget.document.parentWindow.mainParam_typeName = selType.options[selType.selectedIndex].text;
        System.Gadget.document.parentWindow.mainParam_folderPath = selType.options[selType.selectedIndex].value;
        System.Gadget.document.parentWindow.mainEventDetect_moveCancel = false;
        close();
    }
    else
    {
        if(txtPath.value.length>0 || txtNewType.value.length>0)
        {
            // validate the path
            var fso = getFSO();
            if  (fso==null) return;
            if(fso.FolderExists(txtPath.value)==true)
            {
                // verify that the new type is really new...
                if(isInList(selType,txtNewType.value)==false)
                {
                    writeNewType(txtNewType.value,
                                 System.Gadget.document.parentWindow.mainParam_extension,
                                 txtPath.value);
                    // add the path to the settings so the return function can mve the file...
                    System.Gadget.document.parentWindow.mainResult_newPath = txtPath.value;
                    System.Gadget.document.parentWindow.mainParam_typeName = txtNewType.value;
                    System.Gadget.document.parentWindow.mainParam_folderPath = txtPath.value;

                    System.Gadget.document.parentWindow.mainEventDetect_moveCancel = false;
                    close();
                }
                else
                {
                    showMessage("The name [" + txtNewType.value + "] already exists.");
                    System.Sound.beep();
                }
            }
            else
            {
                showMessage("You have specified an inavlid path.");
                System.Sound.beep();
            }
        }
        else
        {
            showMessage("You must enter a name and path to continue.");
            System.Sound.beep();
        }
    }
}

/*============================================================
FUNCTION:   browseButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Allws the user to specify a folder path using the chooseFolder
dialog...
==============================================================*/ 
function browseButton_onclick() 
{
    var folItem = System.Shell.chooseFolder("Select a folder",0);
    if(folItem!=null)
        txtPath.value = folItem.path;
}