////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
The HELPER.JS file contains a set of helper functions that are
not specificlly related to the project (thus not included in CORE).

NOTE: External dependencies should be avoided if at all 
      possible.
*/

/*============================================================
FUNCTION:   instrrev( string, string )
PARAMETERS: s (string) is the full string to be searched
            c (string) is the character to be found
RETURNS:    number specifying the location in the string (s)
            in which the string (c) was found.
CREATED BY: David E. Craig
CREATED ON: 04/24/2007
DESCRIPTION:
Looks through a string in reverese for a specific character
when it is found it retuns that strings position. If it is not
found then it returns zero (0).
==============================================================*/    
function instrrev(s,c)
{
    var retVal = 0;
    for(i=s.length;i>0;i--)
    {
        if(s.substr(i,1)==c)
        {
            retVal=i + 1;
            break;
        }
    }
    return retVal;
}

/*============================================================
FUNCTION:   findItemInArray( array , string )
PARAMETERS: a (array) an array of strings
        f (string) a string to find in the array
RETURNS:    number specifying the location in the 
            array in which the string was found
CREATED BY: David E. Craig
CREATED ON: 04/24/2007
DESCRIPTION:
Looks through the array for the string that is
extracted from the f (string) passed into the function. It
then returns that array index position. If nothing is found
then -1 is returned.
==============================================================*/
function findItemInArray(a, f)
{   

    var retVal=-1;
    if(f==null) return retVal;
    for(i=0;i<a.length;i++)
    {
        if(a[i]!=null)
        {
            if(a[i].toLowerCase()==f.toLowerCase())
            {
                retVal = i;
                break;
            }
        }
    }
    return retVal;
}

/*============================================================
FUNCTION:   sortlist( selectList )
PARAMETERS: lst (a selection list box)
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/26/2007
DESCRIPTION:
Takes the given selection list and then sorts the items within.
==============================================================*/
function sortlist(lst) 
{
    arrText = new Array();

    for(i=1; i<lst.length; i++)  
    {
        arrText[i-1] = lst.options[i].text + "~~~" + lst.options[i].value;
    }

    arrText.sort();

    for(i=1; i<lst.length; i++)  
    {
        var a = arrText[i-1].split("~~~");
        lst.options[i].text = a[0];
        lst.options[i].value = a[1];
    }
}

/*============================================================
FUNCTION:   isInList( selectList , string )
PARAMETERS: lst (a selection list box)
RETURNS:    true/false
CREATED BY: David E. Craig
CREATED ON: 04/26/2007
DESCRIPTION:
Looks within the select list and determines if the string
is within the list. Returns true if it is there.
==============================================================*/
function isInList(lst, s)
{
    for(i=0; i<lst.length; i++)  
    {
        if(s==lst.options[i].text)
            return true;
    }
    
    return false;
}

/*============================================================
FUNCTION:   findInList( selectList , string )
PARAMETERS: lst (a selection list box)
RETURNS:    number
CREATED BY: David E. Craig
CREATED ON: 05/10/2007
DESCRIPTION:
Looks within the select list and retruns the index of the 
string where it is found within the list. Returns -1 if it is 
not found in the list.
==============================================================*/
function findInList(lst, s)
{
    var retVal = -1;
    
    for(i=0; i<lst.length; i++)  
    {
        if(s==lst.options[i].text)
        {
            retVal = i;
            break;
        }
    }
    
    return retVal;
}