﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
SETTINGS0_EVENTS.JS is the core event file for SETTINGS0.HTML.

This is the settings code that allows the user to change which file 
extensions are placed in which folder.

NOTE: External dependencies are added in the parent HTML
*/

var currentTab = Number(-1);
var theTabs = new Array();
var theDivs = new Array();

var blnAddNew = false;
var blnReplace = false;
var origPathVal = "";
var fFlash = false;

/*============================================================
FUNCTION:   init ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/25/2007
DESCRIPTION:
Called as soon as the page loads itself
==============================================================*/
function init()
{
    // initialize all button animation
    initEvents(document);
    loadExtensions();
    loadLocations();
    
    // initialize arrays of tabs and divs
    theTabs[0] = tab0;
    theTabs[1] = tab1;
    theTabs[2] = tab2;
    theTabs[3] = tab3;
    theTabs[4] = tab4;
    theDivs[0] = div0;
    theDivs[1] = div1;
    theDivs[2] = div2;
    theDivs[3] = div3;
    theDivs[4] = div4;
    
    // load the first tab
    loadTab(0);
}

/*============================================================
FUNCTION:   setTabEvents ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Turns on the tab events so they animate
==============================================================*/
function setTabEvents()
{
    // get all the tab elements
    var tds=document.getElementsByTagName("td");
    
    try {
        //loop through the td
        for(i=0;i<tds.length;i++)
        {
            if(tds[i].className=="tab-back")
            {
                // apply the events
                tds[i].onmouseover= new Function("changeTab(this,'tab-hover')");
                tds[i].onmouseout= new Function("changeTab(this,'tab-back')");         
            }
            else
            {
                tds[i].onmouseover = function(){};
                tds[i].onmouseout= function(){};
            }
        }
    } catch (err) { throwError("Initializing tab animations. " + err.description); }
}

/*============================================================
FUNCTION:   loadTab ( int )
PARAMETERS: tab (int) the tab to laod
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/25/2007
DESCRIPTION:
Loads the settings page for the given tab
==============================================================*/
function loadTab(tab)
{
    if(tab!=currentTab)
        switchTabs(tab);
    
    switch(tab)
    {
        case 0:
            loadFirstPage();
            break;
        case 4:
            loadAboutPage();
            break;
    }
    
    // hide the messages
    messageExt.innerText='';
    messageFolder.innerText='';
}

/*============================================================
FUNCTION:   switchTabs ( int )
PARAMETERS: tab (int) the tab to laod
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/25/2007
DESCRIPTION:
Sets up the and actually loads into place the DIV containing
the tag/page information...
==============================================================*/
function switchTabs(tab)
{
    for(i=0;i<5;i++)
    {
        theTabs[i].className="tab-back";
        theDivs[i].style.display="none";
    }
    
    theTabs[tab].className="tab-front";
    theDivs[tab].style.display="inline";
    
    // set the events back up for the tabs
    setTabEvents();
    
    currentTab = tab;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
/// GENERAL OPTIONS PAGE
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

/*============================================================
FUNCTION:   loadFirstPage ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/25/2007
DESCRIPTION:
Loads the settings for the general settings tab...
==============================================================*/
function loadFirstPage()
{
    var folderColor = new String(getSetting("folderColor"));
    var folderStyle = new String(getSetting("folderStyle"));
    if(folderColor=="")
        folderColor="Blue";
    if(folderStyle=="")
        folderStyle="Default";
    
    var folderColorIndex = new Number(findInList(selFolderColor,folderColor));
    var folderSizeIndex = new Number(getSetting("folderSize"));
    var undockSizeIndex = new Number(getSetting("undockSize"));
    var folderStyleIndex = new Number(findInList(selFolderStyle,folderStyle));
    
    selFolderColor.selectedIndex = folderColorIndex;
    selFolderSize.selectedIndex = folderSizeIndex;
    selUndockSize.selectedIndex = undockSizeIndex;
    selFolderStyle.selectedIndex = folderStyleIndex;
    
    if(folderStyle=="Magic")
        selFolderColor.disabled="disabled";
    
    preview.src="../images/bg-small-" + folderColor + "-" + folderStyle +".png";
    
    if(getSetting("extUse")=="true")
    {
        tab3.disabled="";
        extCheckbox.checked=true;
    }
    else
    {
        tab3.disabled="disabled";
        extCheckbox.checked=false;
    }
    
    if(getSetting("turnOffConfirm")=="true")
    {
        confirmCheckbox.checked=true;
    }
    else
    {
        confirmCheckbox.checked=false;
    }

    if(getSetting("folderWatch")=="true")
    {
        watchCheckbox.checked=true;
        extCheckbox.checked=true;
        extCheckbox.disabled="disabled";
    }
    else
    {
        watchCheckbox.checked=false;
        extCheckbox.disabled="";
    }
    
    if(getSetting(FIRST_RUN)=="true")
        chkIntro.checked=false;
    else
        chkIntro.checked=true;
        
    // set the user folder link
    userFolderLink.href="javascript:System.Shell.execute(System.Environment.getEnvironmentVariable('USERPROFILE'),0,0,'explore');";
    
}

/*============================================================
FUNCTION:   extCheckbox_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
The user checked the box to enable/disable file extension
specific file redirection.
1) If enabled - the files will be moved to their registered 
   folders via file extension.
2) If disabled - the user will be prompted where to move the
   file each time they drag it to the folder.
==============================================================*/
function extCheckbox_onclick()
{
    if(extCheckbox.checked==true)
    {
        tab3.disabled="";
        saveSetting("extUse","true");
    }
    else
    {
        tab3.disabled="disabled";
        saveSetting("extUse","false");
    }
}

/*============================================================
FUNCTION:   confirmCheckbox_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/27/2007
DESCRIPTION:
Turns off the option for file move confirmations.
==============================================================*/
function confirmCheckbox_onclick()
{
    if(confirmCheckbox.checked==true)
    {
        saveSetting("turnOffConfirm","true");
    }
    else
    {
        saveSetting("turnOffConfirm","false");
    }
}

/*============================================================
FUNCTION:   watchCheckbox_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 09/28/2007
DESCRIPTION:
User has selected to turn on the watched folder
==============================================================*/
function watchCheckbox_onclick()
{   
    if(watchCheckbox.checked==true)
    {
        saveSetting("folderWatch","true");
        extCheckbox.checked=true;
        extCheckbox.disabled="disabled";
        tab3.disabled="";
        saveSetting("extUse","true");
    }
    else
    {
        saveSetting("folderWatch","false");
        extCheckbox.disabled="";
    }
}

/*============================================================
FUNCTION:   chkIntro_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/12/2007
DESCRIPTION:
User has selected to show the first run dialog again.
==============================================================*/
function chkIntro_onclick()
{
    if(chkIntro.checked==true)
        saveSetting(FIRST_RUN,"false");
    else
        saveSetting(FIRST_RUN,"true");
}

/*============================================================
FUNCTION:   selFolderColor_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
EVENT = ONCHANGE for folder color Drop List 
in SETTINGS0.HTML
==============================================================*/
function selFolderColor_onchange() 
{
    System.Gadget.document.parentWindow.folderColor = 
        selFolderColor.options[selFolderColor.selectedIndex].text;
    saveSetting("folderColor",System.Gadget.document.parentWindow.folderColor);
    preview.src="../images/bg-small-" + getSetting("folderColor") + "-" + 
                                        getSetting("folderStyle") + ".png";
}

/*============================================================
FUNCTION:   selFolderStyle_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 09/28/2007
DESCRIPTION:
EVENT = ONCHANGE for folder style Drop List 
in SETTINGS0.HTML
==============================================================*/
function selFolderStyle_onchange()
{
    if(selFolderStyle.options[selFolderStyle.selectedIndex].text=="Magic")
    {
        selFolderColor.disabled="disabled";
        selFolderColor.selectedIndex = 0;
        selFolderColor_onchange(); // set the folder color to BLUE
    }
    else
    {
        selFolderColor.disabled="";
    }
    
    System.Gadget.document.parentWindow.folderStyle = 
        selFolderStyle.options[selFolderStyle.selectedIndex].text;
    saveSetting("folderStyle",System.Gadget.document.parentWindow.folderStyle);
    preview.src="../images/bg-small-" + getSetting("folderColor") + "-" + 
                                        getSetting("folderStyle") + ".png";    
}

/*============================================================
FUNCTION:   selFolderSize_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
EVENT = ONCHANGE for Docked folder size Drop List 
in SETTINGS0.HTML
==============================================================*/
function selFolderSize_onchange() 
{
    System.Gadget.document.parentWindow.folderSize = 
        selFolderSize.selectedIndex;
    saveSetting("folderSize",selFolderSize.selectedIndex);
}

/*============================================================
FUNCTION:   selUndockSize_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/16/2007
DESCRIPTION:
EVENT = ONCHANGE for Undocked folder size Drop List 
in SETTINGS0.HTML
==============================================================*/
function selUndockSize_onchange()
{
    System.Gadget.document.parentWindow.undockSize = 
        selUndockSize.selectedIndex;
    saveSetting("undockSize",selUndockSize.selectedIndex);
}


////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
// FOLDER FORM EVENTS
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

/*============================================================
FUNCTION:   loadLocations ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Loads the File Locations list...
==============================================================*/
function loadLocations()
{
    var fil= coreOpenSettings(1);
    if(fil==null) return false;
    
    var cnt = 1;
    try {
        while(fil.AtEndOfStream==false)
        {
            var loc = fil.ReadLine();
            var ext = fil.ReadLine();
            var path = fil.ReadLine();
            
            selItems.options[selItems.length] = new Option(loc, path);
            cnt++;
        }
        fil.Close();
    } catch (err) { 
        throwError("Reading settings file. " + err.description); 
        return false;
    }
    
    sortlist(selItems);
    return true;
}

/*============================================================
FUNCTION:   newButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Setup the form so that the user can add a new folder location
name and browse for the folder location...
Set the blnAddNew flag!
==============================================================*/
function newButton_onclick() 
{
    newTable.style.visibility="";
    selItems.disabled = "disabled";
    disableButton(newButton);
    disableButton(deleteButton);
    nameText.disabled="";
    blnAddNew=true;
}

/*============================================================
FUNCTION:   selFolders_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
The user has selected a new folder. The delete button will now
be available as well as the path locaton and name (read-only).
The user is NOT able to change a location name.
==============================================================*/
function selItems_onchange() 
{
    var folName = selItems.options[selItems.selectedIndex].text
    var folPath = selItems.options[selItems.selectedIndex].value
    nameText.value = folName;
    pathText.value = folPath;
    
    enableButton(deleteButton);
    disableButton(saveButton);
    disableButton(newButton);
    
    //disableButton(cancelButton);
    origPathVal = pathText.value;
    newTable.style.visibility="";
}

/*============================================================
FUNCTION:   cancelButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
User clicked cancel - reset everything.
==============================================================*/
function cancelFoldersButton_onclick() 
{
    resetFoldersForm();
}

/*============================================================
FUNCTION:   saveButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Validate the form data...
If the blnAddNew flag is enabled then save new
Else update the path/folder for the existing location
==============================================================*/
function saveButton_onclick() 
{
    var name = new String(nameText.value);
    var path = new String(pathText.value);
       
    // vlidate that the form data is filled out...
    if(name.length > 0 && path.length>0)
    {
        // validate the path...
        var fso = getFSO();
        if(fso==null) return;
        if(fso.folderExists(path)==false)
        {
            throwError("You have specified an invalid folder path.");
        }
        else
        {
            if(blnAddNew==true)
            {
                writeNewType(name,"",path);
                resetFoldersForm();
                showMessage("Saved sucessfully!");
            } 
            else
            {        
                updateType(name, path);
                selItems.options[selItems.selectedIndex].value = path;
                disableButton(saveButton);
                disableButton(cancelButton);
                origPathVal = ""
                showMessage("Saved sucessfully!");
            } // end new/update
        } // end folder validation
    }
    else
    {
        throwError("You must specify a name and a path.");
    } // end validate form data
}

/*============================================================
FUNCTION:   deleteButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Delete the selected folder from the settings file.
==============================================================*/
function deleteButton_onclick() 
{
    if(selItems.selectedIndex>0)
    {
        var folName = selItems.options[selItems.selectedIndex].text;
        var ans = vbconfirm("Are you sure you want to delete the registered folder " +
                            "location: \n" + folName + "?\n\n" +
                            "All registered extensions in this folder location will " +
                            "be removed as well.", APP_NAME);
        
        if (ans==true)
        {
            removeType(folName);
            resetFoldersForm();
            showMessage("Removed successfully!");
        }
    }
}

/*============================================================
FUNCTION:   browseButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
The user clicked browse. Show the folder browser dialog...
Update the results on the form in the pathText box.
==============================================================*/
function browseButton_onclick() 
{
    var folItem = System.Shell.chooseFolder("Select a folder",0);
    if(folItem!=null)
    {
        pathText.value = folItem.path;
        if (pathText.value!=origPathVal)
        {
            enableButton(saveButton);
            enableButton(cancelButton);
        }
    }
}

/*============================================================
FUNCTION:   pathText_onkeypress ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
User changed the text of the path box. Enable the save and 
cancel buttons.
==============================================================*/
function pathText_onkeypress()
{
    if(pathText.text!=origPathVal)
    {
        enableButton(saveButton);
        enableButton(cancelButton);
    }
    else
    {
        disableButton(saveButton);
        disableButton(cancelButton);
    }
}

/*============================================================
FUNCTION:   resetForm ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Reset the form to the intial state and then reload the data.
==============================================================*/
function resetFoldersForm()
{
    selItems.options.length = 0;
    selItems.disabled = "";
    selItems.options[selItems.length] = new Option("", "");
    pathText.value = "";
    nameText.value="";
    nameText.disabled="disabled";
    disableButton(deleteButton);
    newTable.style.visibility="hidden";
    blnAddNew = false;
    enableButton(newButton);
    origPathVal = "";
    loadLocations();
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
/// FILE EXTENTSIONS OPTIONS PAGE
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

/*============================================================
FUNCTION:   loadExtensions ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
Loads the File Extensions list...
==============================================================*/
function loadExtensions()
{
    var fil = coreOpenSettings(1);
    if (fil==null) return false;
  
    var cnt = 1;
    try {
        while(fil.AtEndOfStream==false)
        {
            var loc = fil.ReadLine();
            var ext = fil.ReadLine();
            var path = fil.ReadLine();
            
            var x = ext.split(";");
            for(i=0;i<x.length;i++)
            {
                if(x[i].length>0)
                    selExtensions.options[selExtensions.length] = new Option(x[i], cnt);
            }
            selFolders.options[selFolders.length] = new Option(loc, path);
            cnt++;
        }
        fil.Close();
    } catch (err) { 
        throwError("Reading settings file. " + err.description); 
        return false;
    }
    
    // sort the extensions list
    sortlist(selExtensions);
    // success
    return true;
}

/*============================================================
FUNCTION:   addButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
EVENT = ADD BUTTON in SETTINGS1.HTML. Gets the new
file extension to be added from the user and loads it into
the list.
==============================================================*/
function addButton_onclick() 
{
    // hide the drop list (move it to a hidden part of the form)
    // and insert an input box on the fly
    tempDiv.innerHTML=moveSpace.innerHTML;
    moveSpace.innerHTML="<input class='control-style' id='newText' style='width:192px' onkeypress='return newText_onkeypress()' />";
    // change the caption text
    moveLabel.innerText="Enter the new file extension below:";
    
    // unhide the file chooser
    folderTable.style.visibility="";
    selExtensions.disabled = "disabled";
    selFolders.selectedIndex = -1;

    //set flags
    blnAddNew = true;
    blnReplace = true;

    // disabled all buttons
    disableButton(addButton);
    disableButton(removeButton);
    disableButton(applyButton);
}

/*============================================================
FUNCTION:   cancelButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/06/2007
DESCRIPTION:
Resets the form.
==============================================================*/
function cancelButton_onclick()
{
    resetForm(true);    
}

/*============================================================
FUNCTION:   newText_onkeypress ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/01/2007
DESCRIPTION:
This event is added when the (+) add button is clicked on the
form. When the user types a letter, the textbox is validated 
for iput as well as the folder. If both are valid, show the
save/apply button.
==============================================================*/
function newText_onkeypress()
{
    var val = new String(newText.value);
    if(val.length > 0 && selFolders.selectedIndex>=0)
    {
        enableButton(applyButton);
    }
}

/*============================================================
FUNCTION:   removeButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
EVENT = REMOVE button in SETTINGS1.HTML.
Removes the selected extension from the list.
==============================================================*/
function removeButton_onclick()
{
    if(selExtensions.selectedIndex>0)
    {
        var sectionName = selExtensions.options[selExtensions.selectedIndex].value;
        var ext = selExtensions.options[selExtensions.selectedIndex].text;
        
        var ans = vbconfirm("Are you sure you want to remove this extension?",APP_NAME);
        if(ans==true)
        {
            removeExtension(sectionName,ext);
            // reset the entire form and relad the data
            resetForm(true);
            showMessage("Removed successfully!");
        }
    }
}

/*============================================================
FUNCTION:   resetForm ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
For SETTINGS1.HTML this will eaiter partially reset the form
when the Apply button is clicked or reset the whole form
when a major event like REMOVE is clicked,
==============================================================*/
function resetForm(completely)
{
    selExtensions.disabled = "";
    enableButton(addButton);
    enableButton(removeButton);
    disableButton(applyButton);
    
    if(blnReplace==true)
    {
        moveSpace.innerHTML=tempDiv.innerHTML;
        tempDiv.innerHTML = "";
        moveLabel.innerText="Select a file extension you want to modify:";
        blnReplace = false;
    }
    
    if(completely==true)
    {
        selExtensions.selectedIndex = -1;
        selFolders.selectedIndex = -1;
        folderTable.style.visibility="hidden";
        disableButton(removeButton);
        // blank out the lists
        selExtensions.options.length=0;
        selFolders.options.length=0;
        // add blank items
        selExtensions.options[selExtensions.length] = new Option("","");
        selFolders.options[selFolders.length] = new Option("", "");
        // reload the data
        loadExtensions();
    }
}

/*============================================================
FUNCTION:   applyButton_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
EVENT = APLLY button for SETTINGS1.HTML 
This will update the data in the setting sfile for the changes 
made by the user.
==============================================================*/
function applyButton_onclick() 
{
    var fol = selFolders.options[selFolders.selectedIndex].text;
    
    // is the folder valid?
    if(selFolders.value.length>0)
    {        
        // add the new item
        if(blnAddNew==true)
        {        
            var ext = new String(newText.value);
            // validate the extension first...
            if (ext.length==0)
            {
                // invalid- blank
                throwError("The extension cannot be blank.");
                return;
            }
            else
            {
                if(isInList(selExtensions,ext)==true)
                {
                    // already in the list...show error
                    throwError("The extension [" + ext + "] is already in the list");
                    return;
                } 
            }
            
            // add the extension to the drop list
            selExtensions.options[selExtensions.length] = new Option(ext, selFolders.selectedIndex);
            selExtensions.selectedIndex = selExtensions.length-1;
            
            // write it
            writeNewExtension(fol, ext);
                              
            // reset NEW flag
            blnAddNew = false;
            
            // reset the form
            resetForm(false);
            showMessage("Saved sucessfully!");
        }
        else
        {
            var ext = selExtensions.options[selExtensions.selectedIndex].text
            // get the original group name
            var orig = selFolders.options[selExtensions.options[selExtensions.selectedIndex].value].text;
            // remove the extension from the original group
            removeExtension(orig,ext);
            // write it to the new group
            writeNewExtension(fol, ext);
            resetForm(false);
            showMessage("Saved sucessfully!");
        }
    }
    else
    {
        // invalid folder
        throwError("The folder cannot be left blank.");
        return;
    }
}

/*============================================================
FUNCTION:   selFolders_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
EVENT = ONCHANGE for Folders Drop List in SETTINGS.HTML
Enables the apply button because the user made a change.
==============================================================*/
function selFolders_onchange() 
{
    if(blnAddNew==true)
    {
        var val = new String(newText.value);
        if(selFolders.selectedIndex>0 && val.length>0)
            enableButton(applyButton);
    }
    else
    {
        if(selFolders.selectedIndex>0)
            enableButton(applyButton);
    }
           
}

/*============================================================
FUNCTION:   selExtensions_onchange ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/25/2007
DESCRIPTION:
EVENT = ONCHANGE for Extensions Drop List in SETTINGS.HTML
Shows the folders list and disabled the ability to add/remove 
new items until the user cancels or applys the changes.
==============================================================*/
function selExtensions_onchange() 
{
    if(selExtensions.value.length>0)
    {
        enableButton(removeButton);
        folderTable.style.visibility="";
        selFolders.selectedIndex = selExtensions.options[selExtensions.selectedIndex].value;
    }
}


/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
/// ABOUT OPTIONS PAGE
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

/*============================================================
FUNCTION:   loadAboutPage ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/23/2007
DESCRIPTION:
Loads the proper settings.
==============================================================*/
function loadAboutPage()
{
    checkForUpdate();
    
    if(getSetting("stopRemind") == "true")
        updateCheckbox.checked=false;
    else
        updateCheckbox.checked=true;
}

/*============================================================
FUNCTION:   checkForUpdate ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/23/2007
DESCRIPTION:
Checks the service on the web to see if there is an update
and if there is one,then it loads the update screen.
Essentially this calls the web service on KRYL.COM to see
if there is an update. 

Passes to AJAX the current version where it is checked with
the posted version. If the posted version is newer the word
UPDATED is returned. Otherwise the word NO UPDATE is passed 
back.

The AJAX call then passes control to the parseResponse 
function. 
==============================================================*/
function checkForUpdate()
{
    try {
        var url = UPDATE_URL;
        var pars = 'ver=' + VERSION;
        var myAjax = new Ajax.Request(
                                        url, 
                                    {
                                        method: 'post', 
                                        parameters: pars, 
                                        onComplete: parseResponse
                                    });
    } catch (ex) { /* DO NOTHING */ }
}

/*============================================================
FUNCTION:   parseResponse ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/23/2007
DESCRIPTION:
Parses the AJAX results from the checkSettings function to
see if the word UPDATE is in it...
==============================================================*/
function parseResponse(originalRequest)
{
    var sVer = new String(originalRequest.responseText);
    if(sVer=="UPDATE")
    {
        updateSpan.innerHTML="<br />There is an update available.<br/>" +
                             "Click here to go to the download page.<br /></br />";
        updateSpan.style.visibility="";
        rotateBorder();
    }
    else
    {
        updateSpan.style.visibility="hidden";
    }           
}

/*============================================================
FUNCTION:   updateCheckbox_onclick ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/23/2007
DESCRIPTION:
Enable/disable the option for the FLYOUT update that comes from
the check for update loop in the main form.
==============================================================*/
function updateCheckbox_onclick()
{
    if(updateCheckbox.checked==true)
        saveSetting("stopRemind","false");
    else
        saveSetting("stopRemind","true");
}

/*============================================================
FUNCTION:   downloadPage ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/23/2007
DESCRIPTION:
User clicked the blinking span that denotes an update is 
available to download.
==============================================================*/
function downloadPage()
{
    System.Shell.execute(DL_URL,0,0,"");
}

/*============================================================
FUNCTION:   rotateBorder ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/23/2007
DESCRIPTION:
Eye candy to catch the users attention.
==============================================================*/
function rotateBorder()
{
    if(currentTab==3)
    {
        if(!fFlash)
        {
            updateSpan.style.borderStyle="dashed";
            fFlash=true;
        }
        else
        {
            updateSpan.style.borderStyle="dotted";
            fFlash=false;
        }
        
        window.setTimeout("rotateBorder()",500);
    }
}